# C Programming Table of Contents

- [C-4305L-TM C Programming: Introduction to C](Introduction/README.md)
    - [Objectives](Introduction/objectives.md)
    - [Definitions](Introduction/Definitions.md)
    - [Features](Introduction/features.md)
    - [C Specifics](Introduction/C-specifics.md)
    - [GCC](Introduction/gcc.md)
        - [Demonstration Lab](Labs/Demonstration/Greetings.md)
    - [CMake](Introduction/cmake.md)
    - [Documentation](Introduction/Documentation.md)
        - [Performance Lab](Labs/Performance/documentation.md)


- [C-4310L-TM C Programming: Variables and Data Types](Variables/README.md)
    - [Objectives](Variables/objectives.md)
    - [Coding Style Guide](Variables/Coding_style_guide.md)
    - [Variable Names](Variables/Variable_names.md)
    - [Data Types](Variables/Data_types.md)
        - [Demonstration Lab](Labs/Demonstration/DataTypes.md)
    - [Sizes](Variables/Sizes.md)
        - [Demonstration Lab](Labs/Demonstration/SizeOf.md)
    - [Declarations](Variables/Declarations.md)
        - [Performance Lab](Variables/performance_labs/lab1.md)  
    - [Keywords](Variables/Keywords.md)
    - [Type Conversions](Variables/Type_conversions.md)
        - [Performance Lab](Variables/performance_labs/lab2.md) 
    - [Additional Practice](Labs/Demonstration/VariableDemos.md)


- [C-4320L-TM C Programming: Input/Output I](IO_part_1/README.md)
    - [Objectives](IO_part_1/objectives.md)
    - [C Streams](IO_part_1/c-streams.md)
    - [Functions](IO_part_1/functions.md)
    - [GetChar & PutChar](IO_part_1/getchar-putchar.md)
        - [Demonstration Lab](Labs/Demonstration/getchar_putchar.md)
        - [Performance Lab](Labs/Performance/putchar_getchar_perf.md)
    - [GetC & PutC](IO_part_1/getc-putc.md)
        - [Demonstration Lab](Labs/Demonstration/getc_putc.md)
        - [Performance Lab](Labs/Performance/getc_putc_perf.md) 
    - [String IO](IO_part_1/string-io.md)
        - [Demonstration Lab](Labs/Demonstration/string-io-demo.md)
        - [Performance Lab](Labs/Performance/string-io-perf.md) 
    - [Printf](IO_part_1/printf.md)
    - [scanf](IO_part_1/scanf.md)
        - [Demonstration Lab](Labs/Demonstration/scanf_1.md)
        - [Demonstration Lab](Labs/Demonstration/scanf_2.md)
        - [Performance Lab](Labs/Performance/scanf_perf.md) 
    - [fprintf & fscanf](IO_part_1/fprintf-fscanf.md)
    - [Buffer Overflows](IO_part_1/Buffer_Overflow.md)
    - [Command Line Arguments](IO_part_1/CLA.md)


- [C-4325L-TM C Programming: Operators and Expressions](Operators_expressions/README.md)
    - [Objectives](Operators_expressions/objectives.md)
    - [Definitions](Operators_expressions/definitions.md)
    - [Arithmetic Operators](Operators_expressions/arithmetic-operators.md)
    - [Relational Operators](Operators_expressions/relational-operators.md)
    - [Logical Operators](Operators_expressions/logical-operators.md)
    - [Assignment Operators](Operators_expressions/assignment-operators.md)
    - [Precedence](Operators_expressions/precedence.md)
        - [Performance Lab](Labs/Performance/Operators_Perf.md)
        - [Performance Lab](Labs/Performance/OrderOfOperations_perf.md)


- [C-4330L-TM C Programming: Bitwise Operators](Bitwise_operators/README.md)
    - [Objectives](Bitwise_operators/objectives.md)
    - [Bitwise Operations](Bitwise_operators/bitwise-operations.md)
    - [Numbering Systems](Bitwise_operators/numbering-systems.md)
    - [Bitwise Operators](Bitwise_operators/bitwise-operators.md)
        - [Performance Lab](Bitwise_operators/performance_labs/Perf_labs.md)
        - [Performance Lab](Bitwise_operators/performance_labs/lab10.md)  
        - [Performance Lab](Bitwise_operators/capstone-1.md) 


- [Arrays & Strings](Arrays_strings/README.md)
    - [Objectives](Arrays_strings/objectives.md)
    - [Coding Style guide](Arrays_strings/Coding_style_guide.md)
    - [Arrays](Arrays_strings/Arrays.md)
    - [Access & Modify Arrays](Arrays_strings/access_modify_Arrays.md)
        - [Demonstration Lab](Labs/Demonstration/accessModifyArrays.md)
        - [Performance Labs](Labs/Performance/Arrays_Perf_labs.md)
    - [Strings](Arrays_strings/strings.md)
        - [Demonstration Lab](Labs/Demonstration/strings_demos.md)
        - [Performance Lab](Labs/Performance/Strings_Perf_labs.md) 
    - [String Methods](Arrays_strings/string_methods.md)


- [C-4335L-TM C Programming: Flow Control](Control_flow/README.md)
    - [Objectives](Control_flow/objectives.md)
    - [Statements & Blocks](Control_flow/statements-blocks.md)
    - [if Statements](Control_flow/conditional-statements.md)
        - [Demonstration Lab](Labs/Demonstration/ifs_demo.md)
        - [Performance Lab](Labs/Performance/ifs_perf.md) 
    - [if-else](Control_flow/if-else.md)
        - [Performance Lab](Labs/Performance/if_else_1.md)
        - [Performance Lab](Labs/Performance/if_else_2.md)
    - [else-if](Control_flow/else-if.md)
        - [Performance Lab](Labs/Performance/else_if_1.md)
        - [Performance Lab](Labs/Performance/else_if_2.md)
    - [switch statements](Control_flow/switch.md)
        - [Performance Lab](Labs/Performance/switch_1.md)
        - [Performance Lab](Control_flow/performance_labs/Lab14.md)
    - [Loops](Control_flow/loops.md)
        - [Performance Lab](Labs/Performance/for_loops.md)
    - [while loops](Control_flow/while-loops.md)
        - [Performance Lab](Labs/Performance/while.md)
    - [do while loops](Control_flow/do-while.md)
        - [Performance Lab](Labs/Performance/do_while.md)
    - [Break](Control_flow/break.md)
        - [Demonstration Lab](Labs/Demonstration/break_demo.md)
        - [Performance Lab](Labs/Performance/break.md) 
    - [Nested Control Flow](Control_flow/nested-control-flow.md)
        - [Peformance Lab](Labs/Performance/nested_cf.md)


- [C-4345L-TM C Compiler](C_compiler/README.md)
    - [Objectives](C_compiler/objectives.md)
    - [C Compiler General](C_compiler/compiler_general.md)
    - [Compilation Process](C_compiler/compilation_process.md)
    - [Manual Linking](C_compiler/manual_linking.md)
        - [Performance Lab](C_compiler/demonstration_labs/manual_linking.md) 

    
- [C-4350L-TM C Preprocessor](Preprocessor/README.md)
    - [Objectives](Preprocessor/objectives.md)
    - [Coding Style Guide](Preprocessor/coding_style_guide.md)
    - [Stub Code](Preprocessor/stub_code.md)
    - [Directives](Preprocessor/directives.md)
        - [Performance Lab](Preprocessor/performance_labs/lab24.md) 
    - [Hash Operator](Preprocessor/hash_operator.md)
    - [Double Hash](Preprocessor/double_hash.md)
    - [Undef](Preprocessor/undef.md)
    - [Conditional Compilation](Preprocessor/conditional_compilation.md)
        - [Performance Lab](Preprocessor/performance_labs/Lab25.md) 


- [C-4340L-TM C Programming: Functions](Functions/README.md)
    - [Objectives](Functions/objectives.md)
    - [Functions](Functions/functions.md)
    - [Function Basics](Functions/function_basics.md)
        - [Demonstration Lab](Labs/Demonstration/function-prototypes.md)
        - [Performance Lab](Labs/Performance/healthy_substitutions.md)
    - [Scope Rules](Functions/scope_rules.md)
    - [Storage Class Specifiers](Functions/storage_class_specifiers.md)
    - [Header Files](Functions/header_files.md)
        - [Demonstration Lab](Labs/Performance/headers.md)
    - [Recursion](Functions/recursion.md)
        - [Performance Labs](Functions/performance_labs/Perf_labs.md)


- [C-4355L-TM C Programming: Pointers and Advanced Arrays](Pointers_Arrays/README.md)
    - [Objectives](Pointers_Arrays/objectives.md)
    - [Coding Style Guide](Pointers_Arrays/coding_style_guide.md)
    - [Definitions](Pointers_Arrays/definitions.md)
    - [Endianness](Pointers_Arrays/endianness.md)
    - [Memory Visualizaion](Pointers_Arrays/memory_visualization.md)
    - [Memory Operators](Pointers_Arrays/Memory_Operators.md)
        - [Demonstration Lab](Labs/Demonstration/memoryOps.md)
        - [Performance Lab](Labs/Performance/MemOpsLab.md)
    - [Arrays Review](Pointers_Arrays/Arrays_Review.md)
    - [Address Arithmetic](Pointers_Arrays/Address_Arithmetic.md)
        - [Demonstration Lab](Labs/Demonstration/LittleInt.md)
        - [Performance Lab](Labs/Performance/PerLab_string_Splitter.md) 
    - [Function Arguments](Pointers_Arrays/function_Arguments.md)
        - [Performance Lab](Labs/Performance/surfin_bird.md)
    - [Pointer Arrays](Pointers_Arrays/Pointer_Arrays.md)
    - [Multi-Dimensional Arrays](Pointers_Arrays/Multi_Dim_Arrays.md)
        - [Demonstration Lab](Labs/Demonstration/battleship.md)
        - [Performance Arrays](Labs/Performance/tic_tac_toe.md) 
    - [Function Pointers](Pointers_Arrays/function_pointers.md)
        - [Demonstration Lab](Labs/Demonstration.Demonstration/cliCalculator.md)
        - [Performance Lab](Labs/Performance/texas.md) 
    - [Double Pointers](Pointers_Arrays/double_pointers.md)


- [C-4365L-TM C Programming: Memory Management](Memory_Management/README.md)
    - [Objectives](Memory_Management/objectives.md)
    - [Stack Based Memory](Memory_Management/stack_memory.md)
    - [Heap Based Memory](Memory_Management/heap_memory.md)
    - [C Standard Library](Memory_Management/c_standard_lib.md)
        - [Demo Lab - Memory Management](Labs/Demonstration/MemDemo1.md)
        - [Demo Lab - Malloc 1](Labs/Demonstration/mallocDemo1.md)
        - [Demo Lab - Malloc 2](Labs/Demonstration/mallocDemo2.md)
        - [Performance Lab](Labs/Performance/memLab.md)
    - [Valgrind](Memory_Management/performance_labs/Valgrind_tool.md)
        - [Valgrind Demonstrations](Labs/Demonstration/valgrind_demo_labs.md)
        - [Performance Lab](Labs/Performance.Performance/Valgrind_perf_labs.md)


- [C-4360L-TM C Programming: Input/Output II](IO_part_2/README.md)
    - [Objectives](IO_part_2/objectives.md)
    - [File Data Type](IO_part_2/file_data_type.md)
    - [Related Functions](IO_part_2/related_functions.md)
        - [Demonstration Lab](Labs/Demonstration/readingDemo1.md)
        - [Performance Lab Mighty Morphin](Labs/Performance/mightyMorphin.md)
        - [Performance Lab Your Song](Labs/Performance/yourSong.md)
        - [Performance Lab Content Copy](Labs/Performance/copyContent.md)
        - [Performance Lab User Names](Labs/Performance/usernames.md)


- [C-4370L-TM C Data Structures](Structs/README.md)
    - [Objectives](Structs/objectives.md)
    - [Structs](Structs/structs.md)
    - [Struct Format](Structs/struct_format.md)
    - [Arrays of Structs](Structs/arrays_of_structs.md)
    - [Struct Visualization](Structs/struct_visualization.md)
        - [Demonstration Lab](Labs/Demonstration/structDemo.md)
        - [Performance Lab](Labs/Performance/structLab.md)
    - [Linked Lists](Structs/linked_lists.md)
        - [Demonstration Lab](Labs/Demonstration/LLDemo1.md)
        - [Demonstration Lab](Labs/Demonstration/LLDemo2.md)
        - [Performance Lab](Labs/Performance/LLLab.md) 
    - [Function Pointers](Structs/function_pointers.md)


- [C-4370L-TM C Algorithms](Error_handling/README.md)
    - [Objectives](Error_handling/objectives.md)
    - [Assert](Error_handling/assert.md)
        - [Demonstration Lab](Labs/Demonstration/assertDemo.md)
        - [Performance Lab](Labs/Performance/assertLab.md) 
    - [Errno](Error_handling/errno.md)
        - [Demonstration Lab](Labs/Demonstration/Errno.md)
        - [Performance Lab](Labs/Performance/errnoLab.md)
    - [Assert & Errno](Error_handling/assert_vs_errno.md)
        - [Demonstration Lab](Labs/Demonstration/inputError.md)
        - [Performance Lab](Labs/Performance/Lab_output.md) 
    - [Math Functions](Error_handling/Math_functions.md)
    - [Pointers](Error_handling/pointers.md)
    - [Strings & Files](Error_handling/strings_and_files.md)
        - [Collaborative Project](Error_handling/Performance_Labs/project.md) 
    - [LinkedLists](Data_Structures/Linked_list/01_Lesson.md)
        - [CicularLinkedLists](Data_Structures/Linked_list/CircularLinkedList.md)
        - [DoublyLinkedLists](Data_Structures/Linked_list/Doubly.md)
        - [LinkedListLab](Data_Structures/Linked_list/LinkListLab.md)
        - [PerformanceLabs](Data_Structures/Linked_list/Performance_Labs.md)
    - [Stacks](Data_Structures/Stack/01_Lesson.md)
        - [Performance labs](Data_Structures/Stack/Performance_labs.md)
    - [Queue](Data_Structures/Queue/01_Lesson.md)
        - [Performance labs](Data_Structures/Queue/Performance_labs.md)
    - [Trees Performance Labs](Data_Structures/Trees/Performance_Labs.md)
    - [Searching Algorithms](Data_Structures/Searching/01_lesson.md)
        - [Searching](Data_Structures/Searching/SearchingExercises.md)
        - [Performance labs](Data_Structures/Searching/performance_labs.md)
    - [Sorting](Data_Structures/Sorting/01_lesson.md)
        - [Bubblesort lab](Data_Structures/Sorting/BubbleSortlab.md)
        - [Insertsort lab](Data_Structures/Sorting/InsertionSortlab.md)
         - [Selectionsort lab](Data_Structures/Sorting/Selectionsortlab.md)
        - [Quicksort lab](Data_Structures/Sorting/Quicksortlab.md)
        - [Performance labs](Data_Structures/Sorting/Performance_labs.md)


- [Multi-Threading](Multi_Threading/Intro_to_Threads.md)
    - [Objectives](Multi_Threading/objectives.md)
    - [Semaphores and Mutexes](Multi_Threading/Semaphores_Mutexes.md)
    - [Thread Example](Thread_Example_1.md)
    - [Demo Lab](Multi_Threading/Demo_lab_1.md)


- [Debugging](Debugging/README.md)
    - [Objectives](Debugging/objectives.md)
    - [Debugging Process](Debugging/Debugging_Process.md)
    - [Debugging Strategies](Debugging/Debugging_Strategies.md)
    - [Debugging Tools](Debugging/Debugging_Tools.md)
    - [VSCode Debugging](Debugging/vscode_debugging.md)
        - [Debugging Demonstration](Debugging/demonstration_labs/Instructor_led_demos.md)
        - [Debugging Practice](Debugging/performance_labs/Debugging_Exercises.md)
        - [Performance Lab](Debugging/performance_labs/Perf_labs.md)

---------------
---------------
[Autogenerated Part I's](continuous-integration.md)

[**C-4305L-TM C Programming: Introduction to C - Part I**](Introduction/part_i.md)  
[**C-4310L-TM C Programming: Variables and Data Types - Part I**](Variables/part_i.md)  
[**C-4320L-TM C Programming: Input/Output I - Part I**](IO_part_1/part_i.md)  
[**C-4325L-TM C Programming: Operators and Expressions - Part I**](Operators_expressions/part_i.md)  
[**C-4330L-TM C Programming: Bitwise Operators - Part I**](Bitwise_operators/part_i.md)  
[**Arrays & Strings Part I**](Arrays_strings/part_i.md)  
[**C-4335L-TM C Programming: Flow Control - Part I**](Control_flow/part_i.md)  
[**C-4345L-TM C Compiler - Part I**](C_compiler/part_i.md)  
[**C-4350L-TM C Preprocessor - Part I**](Preprocessor/part_i.md)  
[**C-4340L-TM C Programming: Functions - Part I**](Functions/part_i.md)  
[**C-4355L-TM C Programming: Pointers and Advanced Arrays - Part I**](Pointers_Arrays/part_1.md)  
[**C-4365L-TM C Programming: Memory Management - Part I**](Memory_Management/part_i.md)  
[**C-4360L-TM C Programming: Input/Output II - Part I**](IO_part_2/part_i.md)  
[**C-4370L-TM C Data Structures - Part I**](Structs/part_i.md)  
[**C-4370L-TM C Algorithms - Part I**](Error_handling/part_i.md)
[**Multi-Threading Part I**](Multi_Threading/part_i.md)  
[**Debugging Part I**](Debugging/part_i.md)  
